ClawEND = 20 -- 手铐耐久，左键砸手铐-1耐久，右键砸手铐-2耐久

-----------------------------------------

clawed = {}
claw = {}
weapons = {}
weapon = {}

parse('mp_wpndmg', 'claw', 0)
parse('mp_wpndmg_z1', 'claw', 0)

addhook('hit', 'ClawSomebody')
addhook('attack', 'PClaw')
addhook('attack2', 'PClaw2')
addhook('join', 'Initialization')
addhook('select', 'SetWeapon')
addhook('ms100', 'SetWeapon2')
addhook('drop', 'CannotDrop')
addhook('die', 'StripClaw')
addhook('walkover', 'CannotCollect')
addhook('startround', 'UnclawedEveryone')

function Unclawed(id)
	clawed[id] = 0
	if claw[id] then
		freeimage(claw[id])
	end
	claw[id] = nil
	parse('equip', id, 50)
	parse('setweapon', id, 50)
	parse('strip', id, 78)
	if weapon[id] then
		for _, value in ipairs(weapon[id]) do
			parse('equip', id, value)
			parse('setammo', id, value, weapons[id][value][1], weapons[id][value][2])
		end
	end
	weapon[id] = {}
end
function OnClawed(id)
	clawed[id] = ClawEND
	claw[id] = image('gfx/!jail by lubo!/cuffs.png', 3, 0, id + 200)
	local objectlist = object(0, 'table')
	weapons[id] = {}
	weapon[id] = {}
	for _, value in ipairs(playerweapons(id)) do
		if value ~= 50 and value ~= 55 then
			table.insert(weapon[id], value)
			weapons[id][value] = {}
			weapons[id][value][1], weapons[id][value][2] = playerammo(id, value)
			parse('strip', id, value)
		end
	end
	parse('equip', id, 78)
	parse('setweapon', id, 78)
	parse('strip', id, 50)
	parse('sv_soundpos', '"Crazy_Game/Jail/cuffs/lock.wav"', player(id, 'x'), player(id, 'y'))
end
function PoundClaw(id, num)
	if clawed[id] > 0 then
		local face = face(id)
		local x = 0
		local y = 0
		local px = player(id, 'tilex')
		local py = player(id, 'tiley')
		if face == 'up' then
			x = px
			y = py - 1
		elseif face == 'left' then
			x = px - 1
			y = py
		elseif face == 'down' then
			x = px
			y = py + 1
		elseif face == 'right' then
			x = px + 1
			y = py
		end
		if tile(x, y, 'wall') then
			if clawed[id] > num then
				clawed[id] = clawed[id] - num
				parse('sv_soundpos', '"Crazy_Game/Jail/cuffs/hit.wav"', player(id, 'x'), player(id, 'y'))
			else
				Unclawed(id)
				parse('sv_soundpos', '"Crazy_Game/Jail/cuffs/break.wav"', player(id, 'x'), player(id, 'y'))
			end
		end
	end
end

function ClawSomebody(id, source, weapon)
	if weapon == 78 and clawed[source] <= 0 then
		if game('sv_gamemode') ~= '1' then
			if player(id, 'team') ~= player(source, 'team') then
				if clawed[id] <= 0 then
					OnClawed(id)
				else
					Unclawed(id)
					parse('sv_soundpos', '"Crazy_Game/Jail/cuffs/break.wav"', player(id, 'x'), player(id, 'y'))
				end
			elseif player(id, 'team') == player(source, 'team') then
				if clawed[id] > 0 then
					Unclawed(id)
					parse('sv_soundpos', '"Crazy_Game/Jail/cuffs/break.wav"', player(id, 'x'), player(id, 'y'))
				end
			end
		else
			if clawed[id] <= 0 then
				OnClawed(id)
			else
				Unclawed(id)
				parse('sv_soundpos', '"Crazy_Game/Jail/cuffs/break.wav"', player(id, 'x'), player(id, 'y'))
			end
		end
	end
end
function Initialization(id)
	clawed[id] = 0
	claw[id] = nil
	weapons[id] = {}
end

for id = 1, game('sv_maxplayers') do
	Initialization(id)
end

function PClaw(id)
	PoundClaw(id, 1)
end
function PClaw2(id)
	PoundClaw(id, 2)
end
function SetWeapon(id)
	if clawed[id] > 0 then
		parse('setweapon', id, 78)
	end
end
function SetWeapon2(id)
	for num = 1, game('sv_maxplayers'), 1 do
		if player(num, 'exists') then
			if tonumber(clawed[num]) and clawed[num] > 0 then
				parse('setweapon', id, 78)
			end
		end
	end
end
function CannotDrop(id)
	if clawed[id] > 0 then
		return 1
	end
end
function StripClaw(id)
	if clawed[id] > 0 then
		parse('strip', id, 78)
	end
end
function CannotCollect(id)
	if clawed[id] > 0 then
		return 1
	end
end
function UnclawedEveryone()
	for num = 1, 32, 1 do
		if player(num, 'exists') then
			Unclawed(num)
		end
	end
end
